/*
	Player PRO 4.15x PlugIns

	Antoine ROSSET
	16 Tranchees
	1206 GENEVA
	SWITZERLAND
	
	FAX: 022 789 35 03
	Compuserve: 100277,164
*/

#include "MAD.h"
#include "PPPlug.h"

#if defined(powerc) || defined(__powerc)
enum {
		PlayerPROPlug = kCStackBased
		| RESULT_SIZE(SIZE_CODE( sizeof(OSErr)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof( sData*)))
		| STACK_ROUTINE_PARAMETER(2, SIZE_CODE(sizeof( long)))
		| STACK_ROUTINE_PARAMETER(3, SIZE_CODE(sizeof( long)))
		| STACK_ROUTINE_PARAMETER(4, SIZE_CODE(sizeof( PPInfoPlug*)))
};

ProcInfoType __procinfo = PlayerPROPlug;
#else
#include <A4Stuff.h>
#endif


OSErr main( 	sData					*theData,
				long					SelectionStart,
				long					SelectionEnd,
				PPInfoPlug				*thePPInfoPlug)
{
long			i;
Ptr				Sample8Ptr = theData->data;
unsigned short	*Sample16Ptr = (unsigned short*) theData->data;

	if( Sample8Ptr == 0L) return noErr;
	
	switch( theData->amp)
	{
		case 8:
			return noErr;
		break;
		
		case 16:
			for( i = 0; i < theData->size; i++)
			{
				*Sample8Ptr -= 0x80;
				Sample8Ptr++;
			}
		break;
	}
	
	return noErr;
}